SystemOrganization addCategory: #'EjerciciosPoo-OnlineSale'!

Object subclass: #BookSale
	instanceVariableNames: 'sales'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!BookSale methodsFor: 'as yet unclassified' stamp: 'Satelier 6/23/2012 23:27'!
add: aSale 
	sales add: aSale.! !

!BookSale methodsFor: 'as yet unclassified' stamp: 'Satelier 6/24/2012 00:39'!
getSalesOfClient: aClient 
	
	^ sales collect: [:aSale| aSale client = aClient].! !

!BookSale methodsFor: 'as yet unclassified' stamp: 'Satelier 6/23/2012 23:26'!
initialize
	sales := OrderedCollection new.! !

!BookSale methodsFor: 'as yet unclassified' stamp: 'Satelier 6/23/2012 23:39'!
isEmpty 
	^ sales isEmpty.! !

Object subclass: #Cart
	instanceVariableNames: 'productsContained productCatalog client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/20/2012 13:37'!
newWith: aCatalog ofClient: aClient.

	^self new initializeinitializeWith: aCatalog client: aClient! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:26'!
add: aNewProduct quantity: aQuantityOfProduct 
	(aQuantityOfProduct > 0) 
		ifFalse: [self error: 'Cannot add a negative or zero quantity'.].

	(productCatalog includesKey: aNewProduct) 
		ifFalse: [self error: 'The product does not belong to the editorial'.].
		
	productsContained add: aNewProduct withOccurrences: aQuantityOfProduct.
			
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/24/2012 00:24'!
client
	^client.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:51'!
contains: aProduct 
	^ productsContained includes: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/20/2012 13:35'!
initializeinitializeWith: aCatalog client: aClient
	productsContained:= Bag new.
	productCatalog:= aCatalog.
	client := aClient.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 19:44'!
isEmpty 
	^productsContained isEmpty.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:12'!
quantityOf: aProduct
	^productsContained occurrencesOf: aProduct.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:17'!
saleAmount
| anAmount |

	anAmount:=0.
	productsContained do: [ :aSaleItem |  anAmount:= anAmount + (productCatalog at: aSaleItem) ].
	^anAmount.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 20:56'!
size
	^ productsContained size.! !

Object subclass: #Cashier
	instanceVariableNames: 'merchanceProcessorInterface bookSale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:33'!
newWith: aMerchanceProcessorInterface and: aBookSale
	^self new initializeWith: aMerchanceProcessorInterface and: aBookSale

! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'Satelier 6/24/2012 00:32'!
checkOut: aCart withCreditCard: aCreditCard
	| anAmount merchanceResponse |
	(aCart isEmpty ) 
		ifTrue: [self error: 'The cart to be checked out can not be empty'.].

	(aCreditCard isExpiredOn: (MonthOfYear onMonthNumber: ((Date today) monthIndex)  of: ((Date today) year)))
	ifTrue: [self error: 'The credit card is expired'.]. 

	anAmount:= aCart saleAmount.
	
	merchanceResponse := [ merchanceProcessorInterface debitFrom: aCreditCard amount: anAmount] value.
	( merchanceResponse beginsWith: '1') ifTrue: [ self error: merchanceResponse ].
	
	"[ merchanceProcessorInterface debitFrom: aCreditCard amount: anAmount] on: Error do: [ :anError | self error: anError  ]."
	bookSale add: (Sale to: (aCart client) payWith: aCreditCard saled: aCart totalAmount: anAmount).
	^anAmount.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:33'!
initializeWith: aMerchanceProcessorInterface and: aBookSale
	merchanceProcessorInterface :=  aMerchanceProcessorInterface.
	bookSale := aBookSale.! !

Object subclass: #MerchanceProcessorInterface
	instanceVariableNames: 'aMerchanceProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!MerchanceProcessorInterface methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:43'!
debitFrom: aCreditCard amount: anAmount
"	aMerchanceProcessor debitFrom: aCreditCard amount: anAmount"! !

MerchanceProcessorInterface subclass: #MerchanceProcessorInterfaceStub
	instanceVariableNames: 'used debitResponse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!MerchanceProcessorInterfaceStub class methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:44'!
newWith: aBlockOnDebit
	^self new initializeWith:  aBlockOnDebit
! !

!MerchanceProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'Satelier 6/23/2012 20:53'!
debitFrom: aCreditCard amount: anAmount
	| theResponse |

	used := true.
	theResponse:=debitResponse value: aCreditCard value: anAmount.
	(theResponse beginsWith:  '1' ) ifTrue: [ self error: theResponse].
	^theResponse.! !

!MerchanceProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:48'!
initializeWith:  aBlockOnDebit
	used := false.
	debitResponse := aBlockOnDebit.! !

!MerchanceProcessorInterfaceStub methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:42'!
used
	^used.! !

Object subclass: #Sale
	instanceVariableNames: 'client creditCard saledItems amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/24/2012 00:31'!
to: aClient payWith: aCreditCard saled: aCart totalAmount: anAmount
	^self new initializeWith: aClient payWith: aCreditCard saled: aCart totalAmount: anAmount.! !

!Sale methodsFor: 'as yet unclassified' stamp: 'Satelier 6/24/2012 00:33'!
client
	^client.! !

!Sale methodsFor: 'as yet unclassified' stamp: 'Satelier 6/24/2012 00:26'!
initializeWith: aClient payWith: aCreditCard saled: aCart totalAmount: anAmount 
	client:= aClient.
	creditCard:= aCreditCard.
	saledItems:= aCart.
	amount:= anAmount.! !

TestCase subclass: #OnlineSaleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!OnlineSaleTest methodsFor: 'accessing' stamp: 'Satelier 6/23/2012 23:25'!
aBookSale
	^BookSale new.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'Satelier 6/20/2012 13:39'!
aCart: aCatalog
	^Cart newWith: aCatalog ofClient: self aClient.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'Satelier 6/20/2012 13:38'!
aCart: aCatalog ofClient: aClient.
	^Cart newWith: aCatalog ofClient: aClient.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/14/2012 19:35'!
aCashier
	^Cashier new.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'Satelier 6/23/2012 12:07'!
aCatalogWithThreeProducts

	| aCatalog aProduct aSecondProduct aThirdProduct |

	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aThirdProduct := self aThirdProduct.

	aCatalog := self catalog.

	aCatalog add:  (Association key: aProduct value: 10).
	aCatalog add:  (Association key: aSecondProduct value: 20).
	aCatalog add:  (Association key: aThirdProduct value: 30).
	^aCatalog.
	
	

	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/20/2012 13:40'!
aClient
	^1.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:06'!
aExpirationDate
	
	^MonthOfYear onMonthNumber: ((Date today) monthIndex)  of: ((Date today) year-1). 
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'Satelier 6/14/2012 20:05'!
aExpiriedCreditCard
	^CreditCard ownedBy: 'Pepe'  identifiedBy:  '123456789' expiresOn: self aExpirationDate. ! !

!OnlineSaleTest methodsFor: 'accessing' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:29'!
aMerchanceProcessorInterface: responseBlock
	^MerchanceProcessorInterfaceStub newWith: responseBlock! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:21'!
aProduct
	^ '1'.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:21'!
aSecondProduct
	^ '2'.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:21'!
aThirdProduct
	^ '3'.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:41'!
aValidCreditCard
	^CreditCard ownedBy: 'Pepe'  identifiedBy:  '123456789' expiresOn: self validExpirationDate. ! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/23/2012 12:10'!
anotherClient
	^2.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:20'!
catalog
	^Dictionary  new.! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:09'!
test01NewCartCannotContainsProducts

	self assert: ((self aCart: (self catalog)) isEmpty ).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test02GivenACartWhenAddAProductThenTheCartContainThis

	| aCart aCatalog aProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	
	self assert: (aCart contains: aProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:22'!
test03GivenACartWhenAddAProductThenTheCartNotContainAnotherProduct

	| aCart aCatalog aProduct aSecondProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCatalog add:  (Association key: aSecondProduct value: 1).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	
	self deny: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test04GivenACartWhenAddAProductThenTheCartContainsTheQuantityAddedOfThatProduct

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	self assert: (aCart size = 3).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test05GivenACartWhenAddAProductThatAlreadyExistsThenTheCartContainsTheSumOfTheQuantities

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	aCart add: aProduct quantity: 4.
	self assert: (aCart size = 7).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test06GivenACartWhenAddAProductThenTheQuantityShouldNotBeNegative

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	self should: [ aCart add: aProduct quantity: -1] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText = 'Cannot add a negative or zero quantity').
		self assert: aCart isEmpty.
					
		]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:23'!
test07GivenACartWhenAddAProductThenTheQuantityShouldNotBeZero

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCart := self aCart: aCatalog.
	self should: [ aCart add: aProduct quantity: 0] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText='Cannot add a negative or zero quantity').
		self assert: aCart isEmpty.
					
		]


	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:24'!
test08GivenACartWhenAddAProductAndAnotherProductThenTheCartContainsBothProducts

	| aCart aCatalog aProduct aSecondProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCatalog add:  (Association key: aSecondProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:24'!
test09GivenACartWhenAddAProductAndAnotherProductThenTheCartCanReturnAListOfTheProductsWithItsQuantities

	| aCart aCatalog aProduct aSecondProduct|
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCatalog add:  (Association key: aSecondProduct value: 10).
	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:25'!
test10GivenACartWhenAddAProductAndAnotherProductThenTheCartContainsTheCorrectedQuantityOfThem

	| aCart aCatalog aProduct aSecondProduct aThirdProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCatalog add:  (Association key: aProduct value: 10).
	aCatalog add:  (Association key: aSecondProduct value: 10).

	aCart := self aCart: aCatalog.
	aThirdProduct := self aThirdProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aProduct quantity: 2.
	aCart add: aSecondProduct quantity: 1.

	self assert: ((aCart quantityOf: aProduct) = 5).	
	self assert: ((aCart quantityOf: aSecondProduct) = 1).
	self assert: ((aCart quantityOf: aThirdProduct) = 0).! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/13/2012 21:20'!
test11GivenACartWhenAddAProductWhichIsNotInTheCatalogThenTrowNotIncludedInCatalogException

	| aCart aCatalog aProduct |
	
	aCatalog := self catalog.
	aProduct := self aProduct.
	aCart := self aCart: aCatalog.
	self should: [ aCart add: aProduct quantity: 1] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText = 'The product does not belong to the editorial').
		self assert: aCart isEmpty.
					
		]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:34'!
test12AnEmptyCartCannotBeCheckedOut

	| aCart aCatalog  aCashier aCreditCard aMerchanceProcessorInterface aBookSale |
	
	aCatalog := self catalog.
	aCart := self aCart: aCatalog.
	aMerchanceProcessorInterface := self aMerchanceProcessorInterface: ( [:aCreditCardArg :anAmountArg | '0|OK']).
	aBookSale := self aBookSale.
	aCashier :=  Cashier newWith: aMerchanceProcessorInterface and: aBookSale.
	aCreditCard := self aValidCreditCard.
	self should: [ aCashier checkOut: aCart withCreditCard: aCreditCard ] raise: Error withExceptionDo: [:anError | 
		self assert: (anError messageText = 'The cart to be checked out can not be empty').
		self assert: (aCart isEmpty).
		self assert: (aBookSale isEmpty).
		self deny: (aMerchanceProcessorInterface used).
			]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 21:30'!
test13ACartCannotBeCheckedOutWithAnExpiriedCreditCard

	| aCart aCatalog  aCashier aCreditCard aProduct validDate aBookSale aMerchanceProcessorInterface |

	aProduct := self aProduct.
	aCatalog := self catalog.
	aCatalog add:  (Association key: aProduct value: 10).

	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.

	aMerchanceProcessorInterface := self aMerchanceProcessorInterface: ( [:aCreditCardArg :anAmountArg | '0|OK']).
	aBookSale := self aBookSale.
	aCashier :=  Cashier newWith: aMerchanceProcessorInterface and: aBookSale.

	aCreditCard := self aExpiriedCreditCard.

	self should: [ aCashier checkOut: aCart withCreditCard: aCreditCard ] raise: Error withExceptionDo: [:anError |

		self assert: (anError messageText = 'The credit card is expired').
		self assert: (aCart contains: aProduct).
		self assert: (aBookSale isEmpty).
		self deny: (aMerchanceProcessorInterface used).
		]
	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'Satelier 6/23/2012 13:04'!
test14GivenToCheckOutAFullCartWithAValidCreditCardThenTheSaleWasSuccessfulyDone

	| aCart aCatalog  aCashier aCreditCard aProduct validDate aBookSale aMerchanceProcessorInterface anAmount |

	aProduct := self aProduct.
	aCatalog := self catalog.
	aCatalog add:  (Association key: aProduct value: 10).

	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.

	aMerchanceProcessorInterface := self aMerchanceProcessorInterface: ( [:aCreditCardArg :anAmountArg | '0|OK']).
	aBookSale := self aBookSale.
	aCashier :=  Cashier newWith: aMerchanceProcessorInterface and: aBookSale.

	aCreditCard := self aValidCreditCard.
	anAmount := aCashier checkOut: aCart withCreditCard: aCreditCard.
	self assert: (anAmount = 30).
	self deny: (aBookSale isEmpty).
	self assert: (aMerchanceProcessorInterface used).

	

	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'Satelier 6/23/2012 23:19'!
test15GivenACartToChechOutWhenTheMerchanceProcessorGivesAnExceptionThenTheSaleNotConcrete

	| aCart aCatalog  aCashier aCreditCard aProduct validDate aBookSale aMerchanceProcessorInterface anAmount |

	aProduct := self aProduct.
	aCatalog := self catalog.
	aCatalog add:  (Association key: aProduct value: 10).

	aCart := self aCart: aCatalog.
	aCart add: aProduct quantity: 3.

	aMerchanceProcessorInterface := self aMerchanceProcessorInterface: ( [:aCreditCardArg :anAmountArg | '1|An Error']).
	aBookSale := self aBookSale.
	aCashier :=  Cashier newWith: aMerchanceProcessorInterface and: aBookSale.

	aCreditCard := self aValidCreditCard.

	anAmount := 0.
	self should: [(anAmount := aCashier checkOut: aCart withCreditCard: aCreditCard) ]
		raise: Error withExceptionDo: [:anException | 
		self assert: (anAmount = 0).
		self assert: (anException messageText beginsWith: '1|').
		self assert: (aBookSale isEmpty).
		self assert: (aMerchanceProcessorInterface used).
		].

	

	! !

!OnlineSaleTest methodsFor: 'test' stamp: 'Satelier 6/24/2012 00:39'!
test16GivenTwoSalesFromTheSameClientThenCanListThem

	| aProduct aCart anotherCart aCatalog aCashier aCreditCard validDate aBookSale aMerchanceProcessorInterface anAmount |

	aProduct := self aProduct.

	aCatalog := self aCatalogWithThreeProducts.
	aCart := self aCart: aCatalog ofClient: self aClient.
	anotherCart := self aCart: aCatalog ofClient: self aClient.	
	aCart add: aProduct quantity: 3.
	anotherCart add: aProduct quantity: 4.

	aMerchanceProcessorInterface := self aMerchanceProcessorInterface: ( [:aCreditCardArg :anAmountArg | '0|OK']).
	aBookSale := self aBookSale.
	aCashier :=  Cashier newWith: aMerchanceProcessorInterface and: aBookSale.

	aCreditCard := self aValidCreditCard.

	anAmount := aCashier checkOut: aCart withCreditCard: aCreditCard.		
	anAmount := anAmount + (aCashier checkOut: anotherCart withCreditCard: aCreditCard).

	aBookSale getSalesOfClient: self aClient.
	self assert: ( (aBookSale getSalesOfClient: self aClient) capacity = 2 )
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztynPabloSatelier 6/18/2012 20:06'!
validExpirationDate
		
		^MonthOfYear onMonthNumber: ((Date today) monthIndex)  of: ((Date today) year+1).! !
